// <editor-fold defaultstate="collapsed" desc="Importy (NetBeans)">
package semestralka1;

import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import org.jdesktop.application.Action;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import java.awt.event.WindowEvent;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import org.netbeans.lib.awtextra.AbsoluteLayout;


/**
 * The application's main frame.
 */
// </editor-fold>


public class Semestralka1View extends FrameView {
    // <editor-fold defaultstate="collapsed" desc="Premenne">
    
    //Vyctovy typ pre stav hry (OFFLINE - Hra nie je zahajena, ZADAVA_LODE - Hraci zadavaju lode, TAH - Hraci hraju)
    enum Stav { OFFLINE, ZADAVA_LODE, TAH }
    
    //Hraci
    private hrac hr1;
    private hrac hr2;
    
    //Aktualny hrac, ktory je na tahu
    private hrac aktualnyHr;
    
    //Informacie o hre
    private int pocetLodiek = 10;
    private Dimension velkost_pola;
    private Stav state = Stav.OFFLINE;
    
    // </editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="Konstruktor a zakladne funkcie (z casti NetBeans, z casti moj kod)">
    public Semestralka1View(SingleFrameApplication app) {
        super(app);
        initComponents();
        
        //zakaze zmenu velkosti pola
        this.getFrame().setResizable(false);
        
        //nacita zdroje
        org.jdesktop.application.ResourceMap resourceMap1 = org.jdesktop.application.Application.getInstance(semestralka1.Semestralka1App.class).getContext().getResourceMap(Semestralka1View.class);

        //zmeni ikonu v zahlavi okna
        this.getFrame().setIconImage(resourceMap1.getImageIcon("APP.icon").getImage());
        this.getFrame().setLocationByPlatform(true);//dovoli systemu nastavit poziciu okna
        
        this.getFrame().setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);//nastavi akciu pri zavreti okna
        
        //priradi funkciu CloseApp ako ovladanie akcie zatvarania
        final Semestralka1View xxx = this;
        this.getFrame().addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e)
            {
                xxx.CloseApp();
            }
        });
        
        //odstrani jScrollPane1 z jPanel1, tj. zobrazi len obrazok
        jPanel1.remove(jScrollPane1);
        
        //nastavi velkost okna a odstrani vsetky prvky z jPanel2
        final JFrame a = this.getFrame();
        EventQueue.invokeLater(new Runnable() {
            public void run() {
                a.setSize(203, 260);
                jPanel2.removeAll();
            }
        });
        
        //Nastavi absolutny layout pre jPanel2
        jPanel2.setLayout(new AbsoluteLayout());
    }

    //vola sa pri zatvoreni okna
    private void CloseApp(){
        this.getFrame().dispose();//uvolni zdroje tohto okna
        System.exit(0);//ukonci aplikaciu
    }    
    // </editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="Moj kod">    
    
    // <editor-fold defaultstate="collapsed" desc="Podfunkcie pre Make Pole">
    
    //nastavy velkost okna, vytvori popisky, odstrani predosle prvky v jPanel2
    private void initMakePole(int x, int y, boolean zadane){
        //Nastavi velkost okna
        JFrame a1 = this.getFrame();
        if(zadane){
            a1.setSize((30*x)+325, (30*y)+100);
        } else {
            a1.setSize((30*x)+250, (30*y)+100);
        }
        
        //Odstrani predchadzajuce prvky z panelu a nastavi Layout
        jPanel2.removeAll();
        jPanel2.setLayout(new AbsoluteLayout());
        jPanel2.enableInputMethods(true);
        
        //Vykresli popisky osi
        drawPopisky(x, y, jPanel2);
    }
    
    //Vykresli popisky osi
    private void drawPopisky(int x, int y, JPanel jPanel){
        //Retazec vsetkych pismen abecedy, vzdy vyberie len jedno pismeno podla indexu
        String pismenka = "ABCDEFGHIJKLMNOPQRSTUVZY";        
        
        //Vytvori popisky na osi X
        for(int a = 0; a<x; a++){
            javax.swing.JLabel jLabel = new javax.swing.JLabel();//Vytvori novu instanciu objektu JLabel
            
            //Nastavi vlastnosti
            jLabel.setText((a+1) + "");
            jLabel.setName("jLabelX" + (a+1));
            
            //Prida a vykresli textove pole na paneli
            jPanel.add(jLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints((30*a)+30, 5, -1, -1));//(odsadenie zhora, odasdenie zlava, sirka, vyska)
        }
        
        //Vytvori popisky na osi Y
        for(int a = 0; a<y; a++){
            javax.swing.JLabel jLabel = new javax.swing.JLabel();//Vytvori novu instanciu objektu JLabel
            
            //Nastavi vlastnosti
            jLabel.setText(pismenka.charAt(a) + "");
            jLabel.setName("jLabelY" + (a+1));
            
            //Prida a vykresli textove pole na paneli
            jPanel.add(jLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(5, (30*a)+30, -1, -1));//(odsadenie zhora, odasdenie zlava, sirka, vyska)
        }
    }
    
    //vykresli tlacitko podla parametrov a a b
    private void drawButton(int a, int b, JPanel jPanel){
        final javax.swing.JButton Btt = new javax.swing.JButton();//Vytvori novu instanciu objektu JButton
                
        //Nastavi vlastnosti tlacitka    
        Btt.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        Btt.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Btt.setMaximumSize(new java.awt.Dimension(35, 35));
        Btt.setMinimumSize(new java.awt.Dimension(35, 35));
        Btt.setName((a)+ "|" +(b));
        Btt.setPreferredSize(new java.awt.Dimension(35, 35));
        Btt.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
        Btt.enableInputMethods(true);
        Btt.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                StlacTlac(((javax.swing.JButton)e.getSource()).getName(), Btt);
            }
        });
        
        //Prida a vykresli tlacitko na paneli
        jPanel.add(Btt, new org.netbeans.lib.awtextra.AbsoluteConstraints((30*b)+20, (30*a)+20, 30, 30));//(odsadenie zhora, odasdenie zlava, sirka, vyska)
    }
    
    //vykresli tlacitko pre zobrazenie pola aktualneho hraca na pozicii x a y
    private void drawButtonZobraz(int x, int y){
        javax.swing.JButton Btt = new javax.swing.JButton();//Vytvori novu instanciu objektu JButton
        
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(semestralka1.Semestralka1App.class).getContext().getResourceMap(Semestralka1View.class);

        //Nastavi vlastnosti tlacitka    
        Btt.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        Btt.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Btt.setMaximumSize(new java.awt.Dimension(35, 35));
        Btt.setMinimumSize(new java.awt.Dimension(35, 35));
        Btt.setName("ZobrazPole");
        Btt.setIcon(resourceMap.getIcon("jButton1.icon")); // NOI18N
        Btt.setPreferredSize(new java.awt.Dimension(35, 35));
        Btt.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
        Btt.enableInputMethods(true);
        Btt.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                StlacTlacZobraz();
            }
        });
        
        //Prida a vykresli tlacitko na paneli
        jPanel2.add(Btt, new org.netbeans.lib.awtextra.AbsoluteConstraints(y, x, 70, 70));//(odsadenie zhora, odasdenie zlava, sirka, vyska)
    }
    
    //vykresli textove pole podla parametrov a a b
    private void drawLabel(int a, int b, int imageIndex, JPanel jPanel){
        //Nacita zdroje (obrazky)
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(semestralka1.Semestralka1App.class).getContext().getResourceMap(Semestralka1View.class);
        
        javax.swing.JLabel Btt = new javax.swing.JLabel();//Vytvori novu instanciu objektu JLabel
        
        //Prida obrazok podla indexu
        if(imageIndex == 0){
            Btt.setIcon(resourceMap.getIcon("BEE.icon"));
        } else if(imageIndex == 1) {
            Btt.setIcon(resourceMap.getIcon("BVY.icon"));
        } else if(imageIndex == 2) {
            Btt.setIcon(resourceMap.getIcon("B11.icon"));
        }//ak je index iny nevykresli ziaden obrazok iba prazdne pole
        
        //Nastavi vlastnosti pola
        Btt.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        Btt.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        Btt.setMaximumSize(new java.awt.Dimension(35, 35));
        Btt.setMinimumSize(new java.awt.Dimension(35, 35));
        Btt.setName((b)+ "|" +(a));
        Btt.setPreferredSize(new java.awt.Dimension(35, 35));
        Btt.setVerticalAlignment(javax.swing.SwingConstants.CENTER);

        //Prida a vykresli textove pole na paneli
        jPanel.add(Btt, new org.netbeans.lib.awtextra.AbsoluteConstraints((30*b)+20, (30*a)+20, 30, 30));//(odsadenie zhora, odasdenie zlava, sirka, vyska)
    }
    
    // </editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="Podfunkcie pre StlacTlac">
    
    //Zada lodku----------//nazov tlacitka pre zistenie pozicie//Btt-tlacitko same
    private void zadavac(String name,  javax.swing.JButton Btt){
        //Nacita zdroje (obrazky)
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(semestralka1.Semestralka1App.class).getContext().getResourceMap(Semestralka1View.class);    
        
        //Zmeni obrazok tlacitka
        Btt.setIcon(resourceMap.getIcon("B11.icon")); 
        
        //zada lodku na danej pozicii
        aktualnyHr.zadaj_lodku(Integer.parseInt(name.substring(0, name.indexOf("|"))), Integer.parseInt(name.substring(name.indexOf("|")+1)), true);        
        //prekresli hracie pole podla daneho hraca
        MakePole((int)velkost_pola.getWidth(), (int)velkost_pola.getHeight(), aktualnyHr);       
        if(pocetLodiek == aktualnyHr.getPocetLodiek() && aktualnyHr != hr2){//otestuje ci hrac 1 dokoncil zadavanie        
            MakePole((int)velkost_pola.getWidth(), (int)velkost_pola.getHeight());//prekresli pole na ciste pole            
            aktualnyHr.zadane = true;//nastavi priznak "ukoncil zadavanie"
            //zobrazi dialog z oznamom
            JOptionPane.showMessageDialog(this.getFrame(), "Lode zadava 'Hrac 2'", "Lode", JOptionPane.INFORMATION_MESSAGE);            
            //nastavi stav hry na zadavanie pre hraca 2
            setState(Stav.ZADAVA_LODE, hr2);                         
        } else if(pocetLodiek == aktualnyHr.getPocetLodiek()) {//otestuje ci hrac 2 dokoncil zadavanie       
            aktualnyHr.zadane = true;//nastavi priznak "ukoncil zadavanie"            
            if(Math.random() < 0.5){//nahodne vyberie jedneho hraca ktory zacne            
                //HRAC 1
                MakePole((int)velkost_pola.getWidth(), (int)velkost_pola.getHeight(), hr1);//vykresli prazdne pole
                //zobrazi dialog z oznamom
                JOptionPane.showMessageDialog(this.getFrame(), "Lode zadane!\nNa tahu je 'Hrac 1'", "Lode", JOptionPane.INFORMATION_MESSAGE);                
                setState(Stav.TAH, hr1);//nastavi stav hry na "hrac 1 je na tahu"                 
            } else {
                //HRAC 2
                MakePole((int)velkost_pola.getWidth(), (int)velkost_pola.getHeight(), hr2);//vykresli prazdne pole                
                //zobrazi dialog z oznamom
                JOptionPane.showMessageDialog(this.getFrame(), "Lode zadane!\nNa tahu je 'Hrac 2'", "Lode", JOptionPane.INFORMATION_MESSAGE);                
                setState(Stav.TAH, hr2);//nastavi stav hry na "hrac 2 je na tahu"                                    
            }            
        }
    }
    
    //Urobi tah aktualneho hraca
    private void tah(String name,  javax.swing.JButton Btt){
       //Nacita zdroje (obrazky)
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(semestralka1.Semestralka1App.class).getContext().getResourceMap(Semestralka1View.class);    

        //Urobi tah pre aktualneho hraca
        boolean tah = aktualnyHr.tah(Integer.parseInt(name.substring(0, name.indexOf("|"))), Integer.parseInt(name.substring(name.indexOf("|")+1)), ((aktualnyHr==hr1)? hr2 : hr1));        
        if(tah){//Ak trafil                        
            //Zmeni obrazok na znicenu lodku
            Btt.setIcon(resourceMap.getIcon("BVY.icon"));           
            
            //Skontroluje ci vyhral
            if(!chk_vyhral()){
                //Ak nevyhral prejde na dalsi tah
                //zobrazi dialog z oznamom
                JOptionPane.showMessageDialog(this.getFrame(), "Trefa! Pokracuje " + ((aktualnyHr==hr1)? "'Hrac 1'" : "'Hrac 2'"), "Lode", JOptionPane.INFORMATION_MESSAGE);            
                
                MakePole((int)velkost_pola.getWidth(), (int)velkost_pola.getHeight(), aktualnyHr);//Prekresli pole     
            }
        } else {//Ak netrafil
            //Zmeni obrazok na krizik
            Btt.setIcon(resourceMap.getIcon("BEE.icon"));              
            //zobrazi dialog z oznamom
            JOptionPane.showMessageDialog(this.getFrame(), "Netrafil! Pokracuje " + ((aktualnyHr==hr1)? "'Hrac 2'" : "'Hrac 1'"), "Lode", JOptionPane.INFORMATION_MESSAGE);            
            
            MakePole((int)velkost_pola.getWidth(), (int)velkost_pola.getHeight(), ((aktualnyHr==hr1)? hr2 : hr1));//Prekresli pole          
            setState(Stav.TAH, ((aktualnyHr==hr1)? hr2 : hr1));//Zmeni hraca            
        }
    }
   
    //Skontroluje ci aktualny hrac vyhral
    private boolean chk_vyhral(){
        //Skontroluje ci aktualny hrac vyhral
        if(aktualnyHr.chk_vyhral()){//Ak ano
            //zobrazi dialog z oznamom
            JOptionPane.showMessageDialog(this.getFrame(), ((aktualnyHr==hr1)? "'Hrac 1'" : "'Hrac 2'") + " vyhral!", "Lode", JOptionPane.INFORMATION_MESSAGE);            
            jPanel2.removeAll();//Odstrani vsetky prvky z jPanel2,            
            jPanel2.setLayout(new AbsoluteLayout());//zmeni layout            
            jPanel2.enableInputMethods(true);            
            jPanel2.validate();//vynuti prekreslenie panelu
                                
            this.getFrame().setSize(203, 260);//zmeni velkost okna na povodne           
            this.getFrame().validate();//vynuti prekreslenie okna            
            setState(Stav.OFFLINE, null);//zmeni stav na OFFLINE (hra neprebieha) a zrusi odkaz na aktualneho hraca
            return true;//vrati true ze hrac vyhral
        } else {//Ak nie
            return false;//vrati false ze hrac este nevyhral
        }
    }
   
    // </editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="Ovladanie hry">
    
    //Vykresli prazdne hracie pole podla danej velkosti
    //Prepise status na jTextArea1
    private void setStatus(){
        //odstrani obrazok jLabel1
        jPanel1.remove(jLabel1);
        if(jScrollPane1.getParent() != jPanel1){//zisti ci jPanel1 obsahuje jScrollPane1
            //Ak nie tak ho prida
            jPanel1.add(jScrollPane1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 200, jPanel1.getHeight()));
            //Nastavi velkost pre TextAreu
            jTextArea1.setSize(200, jPanel1.getHeight());
        }
        //Nastavi zaciatocne udaje v prvku TextArea
        jTextArea1.setText("Pocet lodiek: " + pocetLodiek + "\n\rVelkost pola: " + (int)velkost_pola.getWidth() + "x" + (int)velkost_pola.getHeight());
        jTextArea1.setText(jTextArea1.getText() + "\n--------------------------\n\n");
        if(state == Stav.TAH){//Otestuje aky je stav hry, ak je hrac na tahu
            //Nastavi udaje v prvku TextArea na udaje o aktualnom skore
            jTextArea1.setText(jTextArea1.getText() + "Hrac 1 trafil: " + (pocetLodiek-hr1.getPocetLodiek()));
            jTextArea1.setText(jTextArea1.getText() + "\nHrac 2 trafil: " + (pocetLodiek-hr2.getPocetLodiek()));
            //a nastavi udaje v prvku TextArea na udaje o tom kto je na tahu
            jTextArea1.setText(jTextArea1.getText() + "\n\nNa tahu je " + ((aktualnyHr==hr1)? "'Hrac 1'" : "'Hrac 2'"));
        } else if(state == Stav.ZADAVA_LODE) {//ak hrac zadava lode
            //Nastavi udaje v prvku TextArea na udaje o tom ktory hrac zadava lode
            jTextArea1.setText(jTextArea1.getText() + "" + ((aktualnyHr==hr1)? "'Hrac 1'" : "'Hrac 2'") + " zadava lode.");
        } else {//ak je hra OFFLINE(nie je zahajena hra)
            //Nastavi udaje v prvku TextArea na prazdny retazec
            jTextArea1.setText("");
            //odstrani prvok jScrollPane1
            jPanel1.remove(jScrollPane1);
            //opat prida obrazok jLabel1
            jPanel1.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 200, 200));            
        }
        
    }
    
    //Vykresli prazdne hracie pole
    private void MakePole(int x, int y){        
        initMakePole(x,y, false);//nastavy velkost okna, vytvori popisky
        
        //Vytvori tlacitka na hracom poli
        for(int a=0; a<y; a++){
            for(int b = 0; b<x; b++){
                //vykresli tlaciko na pozicii a a b v paneli jPanel2
                drawButton(a, b, jPanel2);
            }
        }
        jPanel2.validate();//Vynuti prekreslenie
        this.getFrame().validate();//Vynuti prekreslenie
    }

    //Vykresli hraci pole podla danej velkosti a priznakov daneho hraca
    private void MakePole(int x, int y, hrac hr){        
        initMakePole(x, y, hr.zadane);//nastavy velkost okna, vytvori popisky
        
        //Vytvori tlacitka na hracom poli
        for(int a=0; a<y; a++){
            for(int b = 0; b<x; b++){  
                if(hr.zadane){//Ak su lodky uz zadane
                    if(hr.get_Kroky(a, b) || hr.get_Zhody(a, b)){//Skontroluje ci dane pole neobsahuje nejaky priznak 
                        if(hr.get_Zhody(a, b)){//Skontroluje ci dane pole obsahuje priznak najdenej lodky
                            drawLabel(a, b, 1, jPanel2);//Ak ano vykresli pole z obrazkom znicenej lodky v paneli jPanel2
                        } else {
                            drawLabel(a, b, 0, jPanel2);//Ak nie vykresli pole z obrazkom krizika v paneli jPanel2
                        }                  
                    } else {//Dane pole neobsahuje ziaden priznak
                        drawButton(a, b, jPanel2);//Vykresli tlacitko v paneli jPanel2
                    }  
                } else {//Ak lodky nie su zadane
                    if(hr.get_Zobraz(a, b)){//Skontroluje ci na danej pozicii nie je zadana lodka
                        drawLabel(a, b, 2, jPanel2);//Ak ano vykresli pole z obrazkom lodky v paneli jPanel2
                    } else {
                        drawButton(a, b, jPanel2);//Ak nie vykresli tlacitko v paneli jPanel2
                    }  
                }               
            }
        }
        
        if(hr.zadane){//ak hrac zadal lodky, mozme pouzit, lebo vieme ze nastane, len ked hrac 2 dokonci zadavanie
            //(kedze inak je bud kreslene pole pomocou makpole(int,int,hrac) len ak hrac este nezadal vsetky lode, 
            //alebo sa vykresli prazdne pole pomocou makepole(int,int))
            drawButtonZobraz(20, (x*30)+30);//vykresli dodatocne tlacitko pre zobrazenie hracieho pola
        }
        jPanel2.validate();//Vynuti prekreslenie
        this.getFrame().validate();//Vynuti prekreslenie
    }
    
    //Vola sa pri kliknuti na polozku Nova hra v menu Subor
    private void NovaHra(){
        //Otvori okno NovaHra na ziskanie udajov od uzivatela
        NovaHra okno = new NovaHra(this.getFrame());
        okno.setVisible(true);
        
        //nastavi aktualny pocet lodiek pre danu hru
        pocetLodiek = okno.poc;
        
        //Vykresli prazdne pole o zadanej velkosti
        MakePole(okno.x, okno.y);
        
        //Signalizuje zaciatok hry
        ZacniHru(okno.x, okno.y);
        
        //Prepise status hry v jTextArea1
        setStatus();
        
        //Zrusi zdroje okna nova hra
        okno.dispose();
    }
    
    //Zaciatok hry
    private void ZacniHru(int x, int y){
        //Ulozi velkost hracieho pola
        velkost_pola = new Dimension(x, y);
        //Inicializuje objekty hracov
        hr1 = new hrac(x, y);
        hr2 = new hrac(x, y);
        //Nastavi stav na zadavanie lodiek pre hraca 1
        setState(Stav.ZADAVA_LODE, hr1);
    }
    
    //Nastavenie stavu hry
    private void setState(Stav state, hrac hr){
        //Nastavi aktualny stav hry
        this.state = state;
        //Nastavi aktualneho hraca
        aktualnyHr = hr;
    }
    
    //Vola sa pri kliknuti na lubovolne tlacitko hracieho pola
    //Obsahuje samotne ovladanie hry
    private void StlacTlac(String name,  javax.swing.JButton Btt){
        //Ak je hra vo faze zadavania lodiek
        if(state == Stav.ZADAVA_LODE){
            //Vola funkciu zadavania s parametrom menom tlacitka a samotnym tlacitkom
            zadavac(name, Btt);
        
        //Ak je hra vo faze hladania lodiek hracmi
        } else if(state == Stav.TAH){
            //Vykona tah hraca
            tah(name, Btt);            
        //Ak je hra v rezime OFFLINE
        } else {
            //Nemalo by nikdy nastat, kedze v rezime OFFLINE nie su vykreslene ziadne tlacitka
            JOptionPane.showMessageDialog(this.getFrame(), "Nepovolena akcia!!!\nButton name: " + name + " by nemalo byt vykreslene!\n\nHra sa automaticky ukonci.", "Lode - Chyba aplikacie", JOptionPane.ERROR_MESSAGE);
            System.exit(-1);
        }
        //Prepise status hry v jTextArea1, resp. vykresli obrazok ak hra skoncila.
        setStatus();
    }
    
    //Vola sa pri kliknuti na tlacitko pre zobrazenie hracieho pola
    //Zobrazi hracie pole aktualneho hraca
    private void StlacTlacZobraz(){
        //Vytvori objekt okna pre zobrazenie pola, jPanel1 je nastaveny ako verejny
        ZobrazPole okno = new ZobrazPole(this.getFrame(), (int)(velkost_pola.getWidth()*30+45), (int)(velkost_pola.getHeight()*30+70));//(nadradeny frame, sirka okna, vyska okna)
        
        //odstrani vsetky prvky z panelu jPanel1 na danom okne
        okno.jPanel1.removeAll();
        okno.jPanel1.setLayout(new AbsoluteLayout());//nastavy absolutny layout pre panel jPanel1 na danom okne
        okno.jPanel1.enableInputMethods(true);
        
        //definuje pracovne premenne
        hrac hr = aktualnyHr;
        hrac super1 = (aktualnyHr==hr1)? hr2 : hr1;
        
        //vykresli popisky na jPanel1 na danom okne
        drawPopisky((int)velkost_pola.getHeight(), (int)velkost_pola.getWidth(), okno.jPanel1);
        
        for(int a=0; a<velkost_pola.getHeight(); a++){
            for(int b = 0; b<velkost_pola.getWidth(); b++){      
                if(super1.get_Kroky(a, b) || super1.get_Zhody(a, b) || hr.get_Zobraz(a, b)){//Skontroluje ci dane pole neobsahuje nejaky priznak 
                    if(super1.get_Zhody(a, b)){//Skontroluje ci dane pole obsahuje priznak najdenej lodky, tj. super nasiel moju lodku
                        drawLabel(a, b, 1, okno.jPanel1);//Ak ano vykresli pole z obrazkom znicenej lodky v paneli jPanel1 na danom okne
                    } else if(super1.get_Kroky(a, b)) {//Skontroluje ci dane pole obsahuje priznak kroku, tj. super tu urobil tah ale nenasiel lodku
                        drawLabel(a, b, 0, okno.jPanel1);//Ak ano vykresli pole z obrazkom krizika v paneli jPanel1 na danom okne
                    } else {//Skontroluje ci dane pole obsahuje priznak "tu mam lodku"
                        drawLabel(a, b, 2, okno.jPanel1);//Ak ano vykresli pole z obrazkom lodky v paneli jPanel1 na danom okne
                    }                 
                } else {//Dane pole neobsahuje ziaden priznak
                    drawLabel(a, b, 3, okno.jPanel1);//Ak ano vykresli pole bez obrazku v paneli jPanel1 na danom okne
                }                
            }
        }
        
        //vynuti prekreslenie panelu
        okno.jPanel1.validate();
        okno.setVisible(true);//zobrazi okno
        okno.dispose();//po zavreti uvolni zdroje okna
    }
    // </editor-fold>
    
    // </editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="Generovany kod a zakladne funkcie (NetBeans)">
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();

        mainPanel.setMaximumSize(new java.awt.Dimension(221, 234));
        mainPanel.setName("mainPanel"); // NOI18N

        jSplitPane1.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        jSplitPane1.setDividerLocation(200);
        jSplitPane1.setDividerSize(1);
        jSplitPane1.setName("jSplitPane1"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(semestralka1.Semestralka1App.class).getContext().getResourceMap(Semestralka1View.class);
        jPanel1.setBackground(resourceMap.getColor("jPanel1.background")); // NOI18N
        jPanel1.setName("jPanel1"); // NOI18N
        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jLabel1.setIcon(resourceMap.getIcon("jLabel1.icon")); // NOI18N
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jLabel1.setDoubleBuffered(true);
        jLabel1.setName("jLabel1"); // NOI18N
        jPanel1.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 200, 200));

        jScrollPane1.setBackground(resourceMap.getColor("jScrollPane1.background")); // NOI18N
        jScrollPane1.setBorder(null);
        jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setFont(resourceMap.getFont("jTextArea1.font")); // NOI18N
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(5);
        jTextArea1.setBorder(null);
        jTextArea1.setName("jTextArea1"); // NOI18N
        jScrollPane1.setViewportView(jTextArea1);

        jPanel1.add(jScrollPane1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 200, 310));

        jSplitPane1.setLeftComponent(jPanel1);

        jPanel2.setName("jPanel2"); // NOI18N
        jPanel2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel2.setName("jLabel2"); // NOI18N
        jPanel2.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 90, -1, -1));

        jButton1.setIcon(resourceMap.getIcon("jButton1.icon")); // NOI18N
        jButton1.setText(resourceMap.getString("jButton1.text")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N
        jPanel2.add(jButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(90, 190, 80, 70));

        jSplitPane1.setRightComponent(jPanel2);

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 544, Short.MAX_VALUE)
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane1)
        );

        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(semestralka1.Semestralka1App.class).getContext().getActionMap(Semestralka1View.class, this);
        jMenuItem1.setAction(actionMap.get("NewGame")); // NOI18N
        jMenuItem1.setText(resourceMap.getString("jMenuItem1.text")); // NOI18N
        jMenuItem1.setName("jMenuItem1"); // NOI18N
        fileMenu.add(jMenuItem1);

        jSeparator1.setName("jSeparator1"); // NOI18N
        fileMenu.add(jSeparator1);

        exitMenuItem.setAction(actionMap.get("Quit")); // NOI18N
        exitMenuItem.setText(resourceMap.getString("exitMenuItem.text")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        setComponent(mainPanel);
        setMenuBar(menuBar);
    }// </editor-fold>//GEN-END:initComponents

    @Action
    public void NewGame() {
        NovaHra();
    }

    @Action
    public void Quit() {
        CloseApp();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    // End of variables declaration//GEN-END:variables


}

// </editor-fold>


